"use strict";

exports.__esModule = true;
exports.default = exports.props = void 0;

var _vue = _interopRequireDefault(require("vue"));

var _vueFunctionalDataMerge = require("vue-functional-data-merge");

var _config = require("../../utils/config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NAME = 'BAvatar';
var props = {
  img: String,
  size: String,
  fontSize: String,
  tag: {
    type: String,
    default: 'span'
  },
  variant: {
    type: String,
    default: function _default() {
      return String((0, _config.getComponentConfig)(NAME, 'variant'));
    }
  },
  rounded: {
    type: Boolean,
    default: false
  },
  square: {
    type: Boolean,
    default: false
  } // @vue/component

};
exports.props = props;

var _default2 = _vue.default.extend({
  name: NAME,
  functional: true,
  props: props,
  render: function render(h, _ref) {
    var props = _ref.props,
        data = _ref.data,
        children = _ref.children;
    var imgStyle = props.img ? {
      'background-image': "url(".concat(props.img, ")")
    } : {};
    var sizeStyle = props.size ? {
      width: props.size,
      height: props.size,
      'max-width': props.size,
      'max-height': props.size
    } : {};
    var componentData = {
      class: ['avatar', !props.variant ? 'avatar-secondary' : "avatar-".concat(props.variant), {
        'avatar-rounded': Boolean(props.rounded),
        'avatar-square': Boolean(props.square)
      }],
      style: Object.assign({
        'font-size': props.fontSize || "calc(".concat(props.size, " / 2)")
      }, imgStyle, sizeStyle),
      props: props
    };
    return h(props.tag, (0, _vueFunctionalDataMerge.mergeData)(data, componentData), children);
  }
});

exports.default = _default2;