"use strict";

exports.__esModule = true;
exports.default = void 0;

var _vue = _interopRequireDefault(require("vue"));

var _config = require("../../utils/config");

var _dom = require("../../utils/dom");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var NAME = 'BLoading'; // @vue/component

var _default2 = _vue.default.extend({
  name: NAME,
  model: {
    prop: 'show',
    event: 'input'
  },
  props: {
    variant: {
      type: String,
      default: function _default() {
        return String((0, _config.getComponentConfig)(NAME, 'variant'));
      }
    },
    show: {
      type: Boolean,
      default: false
    },
    type: {
      type: String,
      default: function _default() {
        return String((0, _config.getComponentConfig)(NAME, 'type'));
      }
    },
    small: {
      type: Boolean,
      default: false
    },
    fade: {
      type: Boolean,
      default: function _default() {
        return Boolean((0, _config.getComponentConfig)(NAME, 'fade'));
      }
    },
    fixed: {
      type: Boolean,
      default: function _default() {
        return Boolean((0, _config.getComponentConfig)(NAME, 'fixed'));
      }
    }
  },
  data: function data() {
    return {
      showClass: this.fade && this.show
    };
  },
  watch: {
    show: function show(val) {
      if (val) {
        this.$emit('started');
      } else {
        this.$emit('ended');
      }
    }
  },
  methods: {
    onBeforeEnter: function onBeforeEnter() {
      var _this = this;

      if (this.fade) {
        (0, _dom.requestAF)(function () {
          _this.showClass = true;
        });
      }
    },
    onBeforeLeave: function onBeforeLeave()
    /* istanbul ignore next: does not appear to be called in vue-test-utils */
    {
      this.showClass = false;
    }
  },
  render: function render(h) {
    var $loading;
    var $spinner;
    var slot = (0, _config.getComponentConfig)(NAME, 'slot');

    if (this.show) {
      if (this.$slots.default) {
        $spinner = this.$slots.default;
      } else if (slot && typeof slot === 'string') {
        // slot is pure text
        // _v is createTextVNode method
        $spinner = this._v(slot);
      } else if (_typeof(slot) === 'object') {
        // slot is Vue component
        $spinner = h(slot);
      } else {
        $spinner = h('b-spinner', {
          props: {
            type: this.type,
            label: 'Loading...',
            variant: this.variant || 'primary',
            small: this.small
          }
        });
      }

      $loading = h('div', {
        class: {
          loading: true,
          fade: this.fade,
          show: this.showClass,
          'loading-fixed': this.fixed
        }
      }, [$spinner]);
      $loading = [$loading];
    }

    return h('transition', {
      props: {
        'enter-class': '',
        'enter-active-class': '',
        'enter-to-class': '',
        'leave-class': 'show',
        'leave-active-class': '',
        'leave-to-class': ''
      },
      on: {
        beforeEnter: this.onBeforeEnter,
        beforeLeave: this.onBeforeLeave
      }
    }, $loading);
  }
});

exports.default = _default2;